; 
;     
;   06-01-23
 list p=16F676
 #include<P16F676.inc>
 __CONFIG _CPD_OFF & _CP_OFF & _BODEN & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT

 errorlevel-302

 #define	bank_0      STATUS,RP0
 #define	bank_1	    STATUS,RP0
 #define	_Z	        STATUS,Z
 #define	_C	        STATUS,C
 #define	_GIE		INTCON,GIE
 #define    KEY1        PORTA,3     ;
 #define	D4			PORTC,0 
 #define	D5		    PORTC,1
 #define	D6		    PORTC,2
 #define    D7		    PORTC,3
 #define	RS		    PORTC,4
 #define	E		    PORTC,5

 #define    Razrydka	PORTA,5 
 #define    Zaryd_C		PORTA,2
 #define	In_ADC		PORTA,0

;         
 cblock     0x22
Lcd0,Lcd1,Lcd2,Lcd3,Lcd4,Lcd5,Lcd6,Lcd7	; .
Lcd8,Lcd9,LcdA,LcdB,LcdC,LcdD,LcdE,LcdF	; . 16   LCD
load_data_LCD			;     
Out0,Out1,Out2,Out3,Out4,Out5,Out6,Out7,Out8	;    bin2lcd
Reg_1
Reg_2
Reg_3
Count1
Count_U_Batt
Buf_L,Buf_M,Buf_H,Buf_U	;    bin2lcd
Ut_H1,Ut_L1,Ut_H2,Ut_L2	;   
Flags   	        ;  
; 0 - Flag ACK:   0 -   1 -  
; 1 - Flag NACKM: 0 -   1 -  
; 4 -       
U_Batt_H
U_Batt_L
N_Segment
U_Bat_0,U_Bat_1,U_Bat_2,U_Bat_3,U_Bat_4,U_Bat_5,U_Bat_6,U_Bat_7
U_Bat_8,U_Bat_9,U_Bat_a,U_Bat_b,U_Bat_c,U_Bat_d,U_Bat_e,U_Bat_f
Temp
	endc

;
            org     0                                           
            goto    START          
            org    4                                            
            retfie      
;
START       clrf	INTCON			;   .
            call    0x3FF	        ;   
			bsf  	bank_1			;    1
            movwf   OSCCAL	        ;   
            clrf    WPUA            ; .     
            movlw   b'10000111'     ;
            movwf   OPTION_REG      ;       TMR0 - /256,  
			movlw 	b'00010011'	    ;
			movwf 	TRISA 			;  PORTA - 
			movlw   b'00000000'  	
			movwf 	TRISC 			;     

			movlw	B'00110000'		;      500 .
			movwf	ADCON1

			movlw	b'00001011'		;  1 -  
            movwf   ANSEL           ;  3 -   RA4

			movlw	B'10100110'		; Uref= 1.2V
			movwf	VRCON			;

			bcf		bank_0	    	;  0

			movlw	B'00110000'		; Fosc /4 /8 /65536 = 524 mS - int
			movwf	T1CON			;  

 			movlw	b'00010100'		;        CM2:CM0=100
 			movwf	CMCON			;   RA1.
 	
			clrf	PORTA
			clrf	PORTC
;        22h  7Fh
            movlw   0x20
            movwf   FSR
Load_0		clrf    INDF
            incf    FSR,f
            movlw   0x5f
            subwf   FSR,w
            btfss   _Z
            goto    Load_0 
;-----------------------------------;
			call	Init_LCD
			;-----------------------;
			bsf		Razrydka			
			movlw	"F"
			movwf 	Lcd0
			movlw	"k"
			movwf 	Lcd1
			movlw	"m"
			movwf 	Lcd2
			movlw	" "
			movwf 	Lcd3
			movwf 	Lcd4
			movwf 	Lcd5
			movwf 	Lcd6
			movwf 	Lcd7
			movwf 	Lcd8
			movwf 	Lcd9
			movwf 	LcdA
			movwf 	LcdB
			movwf 	LcdC
			movwf 	LcdD
			movwf 	LcdE
			movwf 	LcdF
			call	LCD_Out
;;
;-----------------------------------------------------------------------;
U_Battareya
			movlw	B'10001101'		;  , AN3(PORTA,4)
			movwf	ADCON0			;  
			call	uS_200
			bsf		ADCON0,GO		;   (  )
			btfsc	ADCON0,GO		;   
			goto	$-1
			bcf 	_C	        	; 1) C   /
			rrf 	ADRESH,w		; 2)  
			movwf 	U_Batt_H		; 3)     .
			bsf 	bank_1			; 4)      2  .
			rrf 	ADRESL,w		; 5)  
  			bcf 	bank_0			; 6) 0
			movwf 	U_Batt_L		; 7)      

			bcf 	_C	        	; 
			rrf 	U_Batt_H,f		;     ,  ,
			rrf 	U_Batt_L,f		;  
			decf	U_Batt_L
;fffffffffffffffffffffffffffffffffff; 
;			movlw	0x7c			;125 - 2,5  
;			movwf	U_Batt_L		;
;-----------------------------------;
			clrf	N_Segment
			movlw	0x64			;  100 - 
			subwf	U_Batt_L,f		; 2,00 -  			
			btfss	_C				;     
			goto	LCD_Ubat_0		;  ,   
			;-----------------------;
			movfw	U_Batt_L		; 			
			sublw	.60
			btfsc	_C
			goto	In_Table
			movlw	.60
			movwf	U_Batt_L		;

In_Table	movfw	U_Batt_L		; 
			call	Table			;
			movwf	N_Segment
;;
LCD_Ubat_0		
			movlw	U_Bat_0			;  			            
            movwf   FSR
xx			movlw	' '				;    
			movwf   INDF			; " " - 
            incf    FSR,f
			incf	Count_U_Batt,f
			btfss	Count_U_Batt,4
			goto	xx	
			;-----------------------;
			movfw	N_Segment		;      	
			btfsc	_Z				;  (   2 )
			goto	LCD_Out_U		;  2    
			movfw	N_Segment
			movwf	Temp		
			;-----------------------;
Ind_U_Batt							; 
			movlw	U_Bat_0			;    			            
            movwf   FSR				;    
cc          movlw   '_'		    	;     
			movwf	INDF
			incf	FSR,f
			decfsz	N_Segment,f
			goto	cc
;-----------------------------------;
LCD_Out_U
			clrf	Count_U_Batt
         	movlw	0xc0	    	;     
            call    Load_command

			movlw	U_Bat_0			;   	
            movwf   FSR
ccc			movfw	INDF			;   	
			call	Load_symbol
			incf	FSR,f
			incf	Count_U_Batt,f
			btfss	Count_U_Batt,4
			goto	ccc
			clrf	Count_U_Batt			
Out						
			goto    Main_Emk   ; U_Battareya   ; 
;;
Table			addwf	PCL,f		
 DT .0,.1,.1,.2,.2,.2,.3,.3,.3,.4,.4,.4,.5,.5,.5,.6,.6,.6,.7,.7,.7,.8,.8,.8  ;24
 DT .9,.9,.9,.10,.10,.10,.11,.11,.11,.12,.12,.12,.13,.13,.13,.14,.14,.14     ;42	
 DT .15,.15,.15,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16,.16  ;60
;;
;--------------------------------------------------------------------------;
Main_Emk
			call	mS_250			;  250
			;-----------------------;
			clrf	Buf_U
			clrf	Buf_H
			clrf	TMR1L
			clrf	TMR1H
			clrf	ADRESH			
			clrf	ADRESL
			clrf	Reg_1
			bcf		PIR1,TMR1IF		;      TMR1

			bcf		Razrydka		;  
			bsf		Zaryd_C 		;   --------

;      
			bsf		T1CON,TMR1ON	;  
			btfss	CMCON,COUT		;   
			goto	$-1
			bcf		Zaryd_C 			
			bcf		T1CON,TMR1ON	;  
;   
 			btfsc	PIR1,TMR1IF
			bsf		Buf_H,0	
			movfw	TMR1H			; 
			movwf	Buf_M
			movfw	TMR1L
			movwf	Buf_L
;PpppppppppppppppppppppppppppppppppP;		
			movlw	.200			;  
			addlw	-1				;   
			btfss	_Z				;   
			goto	$-2				;  
;-----------------------------------;
;   U    . 
Ism_Ut_1
			movlw	B'10000001'		;  ,0
			movwf	ADCON0			;  

			bsf		ADCON0,GO		;   (  )
			btfsc	ADCON0,GO		;   
			goto	$-1
			movfw	ADRESH			
			movwf	Ut_H1
			bsf		bank_1	
			movfw	ADRESL
			bcf		bank_0
			movwf	Ut_L1

			bcf		_C				;   4 ..  
			rlf		Ut_L1,f			;    1,25  5 
			rlf		Ut_H1,f	
			bcf		_C				;		
			rlf		Ut_L1,f
			rlf		Ut_H1,f

			bcf		_C				;  
			btfsc	PIR1,TMR1IF		;     TMR1
			bsf		_C
			rrf		TMR1H,f
			rrf		TMR1L,f			;   2

			incf	TMR1H,w 		;    
			movwf	Reg_1     		; Hi
			incf	TMR1L,w			; Lo
Ut_loop_Test
			nop
			nop
			nop
			nop
			addlw	0xff          	; w:=w-1
			btfsc	_Z		      	;    0
			decfsz	Reg_1,f
			goto	Ut_loop_Test

;-----------------------------------;
;   U    . 
Ism_Ut_2			
			bsf		ADCON0,GO		;  
			btfsc	ADCON0,GO		;   
			goto	$-1
			movfw	ADRESH			;   
			movwf	Ut_H2
			bsf		bank_1
			movfw	ADRESL
			bcf		bank_0
			movwf	Ut_L2
			
			bcf		_C				;   4 ..  
			rlf		Ut_L2,f			;    1,25  5 
			rlf		Ut_H2,f
			bcf		_C				;		
			rlf		Ut_L2,f
			rlf		Ut_H2,f

			movfw	Ut_H2			;  2  1
			subwf	Ut_H1,f			; 1:=1-2
			movfw	Ut_L2
			subwf	Ut_L1,f
			btfss	_C
			decf	Ut_H1,f			;  

;;
			bcf		Flags,0			;     
			movfw	Buf_M
			sublw	0xC4
			btfss	_C
			bsf		Flags,0			;   
			btfsc	PIR1,TMR1IF		;  10000 
			bcf		Flags,0			;  
;-----------------------------------;			
			call	Convert_2_10
			movfw	Out4
			btfss	_Z
			goto	Emk_up_1000     ; 1000   
			movfw	Out5
			btfss	_Z
			goto	Emk_up_1000     ; 10000   
			call	No_Zero         ;     	
	;      " 000esr 000.0mkF"
	;      "        76543   "
			movlw	"."
			movwf 	Lcd4
			movfw	Out0
			movwf 	Lcd3
			movfw	Out1
			movwf 	Lcd5
			movfw	Out2
			movwf 	Lcd6
			movfw	Out3
			movwf 	Lcd7
			movlw	" "

			subwf 	Lcd5,w	;    0  
			btfss	_Z
			goto	Ut_loop
			movlw	"0"		;  "0"
			movwf 	Lcd5
			goto	Ut_loop
Emk_up_1000
			call	No_Zero ;     	
	;      " 000esr 00000mkF"
	;      "        76543   "
			movfw	Out1
			movwf 	Lcd3
			movfw	Out2
			movwf 	Lcd4
			movfw	Out3
			movwf 	Lcd5
			movfw	Out4
			movwf 	Lcd6
			movfw	Out5
			movwf 	Lcd7

Ut_loop
			movlw	.35			;   
			subwf	Ut_L1,w
			btfss	_C
			goto	Esr_loop	;   -  ESR
	;      " Iut Cx<000.0mkF"
	;      " EDCBA98        "
			movlw	"I"
			movwf 	LcdE
			movlw	"u"
			movwf 	LcdD
			movlw	"t"
			movwf 	LcdC
			movlw	" "
			movwf 	LcdB
			movlw	"C"
			movwf 	LcdA
			movlw	"x"
			movwf 	Lcd9
			movlw	"<"
			movwf 	Lcd8
			goto	Emk_Out		;   - ESR  
Esr_loop						;   
			bcf		_C			;  . 
			rrf		TMR1H,f
			rrf		TMR1L,f		;    2
			bsf		Razrydka	;  
			nop	
			nop	
			bcf		Razrydka	;  

			bsf		Zaryd_C 	;   --------
;ooooooooooooooooooooooooooooooo;
			btfss	CMCON,COUT	;   
			goto	$-1

			bcf		Zaryd_C 	;
;ooooooooooooooooooooooooooooooo;
			incf	TMR1H,w
			movwf	Reg_1    	; Hi
			incf	TMR1L,w	    ; Lo
;-------------------------------;
;;
Esr_loop_Test 
			bsf		Razrydka	;  
			bcf		Razrydka	;  
			nop
			nop
			nop
			nop
			addlw	0xff           ; w:=w-1
			btfss	STATUS,Z     ;    0
			decfsz	Reg_1,f
			goto	Esr_loop_Test
			;--------------------;
			clrw
			addlw	0xFF         ;  1mS
			btfss	_Z       	 ; 
			goto	$-2          ; 
			;--------------------;
			;;   
			bsf		ADCON0,GO		;   (  )
			btfsc	ADCON0,GO		;   
			goto	$-1
			nop
			nop
			movfw	ADRESH			
			movwf	Buf_M
			bsf		bank_1
			movfw	ADRESL
			bcf		bank_0
			movwf	Buf_L

			bcf		_C				;   4 ..  
			rlf		Buf_L,f			;    1,25  5 	
			rlf		Buf_M,f	
			bcf		_C				; 	
			rlf		Buf_L,f
			rlf		Buf_M,f

			bcf		_C
			rrf		Buf_M,f
			rrf		Buf_L,f		; 9  - 512
			clrf	Buf_H
			clrf	Buf_U
			call	Convert_2_10
			call	No_Zero ;     	
;	      " 000esr 00000mkF"
;	      "FEDCBA98        "
			movlw	" "
			movwf 	Lcd8
			movlw	"e"
			movwf 	LcdB
			movlw	"s"
			movwf 	LcdA
			movlw	"r"
			movwf 	Lcd9
			movfw	Out0
			movwf 	LcdC
			movfw	Out1
			movwf 	LcdD
			movfw	Out2
			movwf 	LcdE
Emk_Out
			bsf		Razrydka		;  
			btfss	Flags,0			;   
			goto	Emk_Delay
			clrf	Reg_1     		; 256 
			clrw	   				;   
			nop
			addlw	0xFF          	; w:=w-1
			btfss	STATUS,Z      	;    0
			goto	$-3           	;   addlw 4        
			decfsz	Reg_1,f
			goto	$-6				;
Emk_Delay
			call	LCD_Out
			goto	U_Battareya	;Main_Emk   ;  
;;
LCD_Out
;			call	LCD_Scr 		; 
         	movlw	0x80	    	;    1 
            call    Load_command
		    call	mS_25    	    ;
			btfsc	Flags,1			;  
			goto	$+4
			bsf		Flags,1			;  
			movfw	LcdF
			goto	Flash_F
			bcf		Flags,1			; 
			movlw	"*"
Flash_F
			call	Load_symbol
			movfw	LcdE
			call	Load_symbol
			movfw	LcdD
			call	Load_symbol
			movfw	LcdC
			call	Load_symbol
			movfw	LcdB
			call	Load_symbol
			movfw	LcdA
			call	Load_symbol
			movfw	Lcd9
			call	Load_symbol
			movfw	Lcd8
			call	Load_symbol
			movfw	Lcd7
			call	Load_symbol
			movfw	Lcd6
			call	Load_symbol
			movfw	Lcd5
			call	Load_symbol
			movfw	Lcd4
			call	Load_symbol
			movfw	Lcd3
			call	Load_symbol
			movfw	Lcd2
			call	Load_symbol
			movfw	Lcd1
			call	Load_symbol
			movfw	Lcd0
			call	Load_symbol			; 
				RETURN
;;
Convert_2_10		;     LCD
		    bcf   	STATUS,0        ; clear the carry bit
		    movlw 	.32
		    movwf 	Reg_2
		    clrf	Out4      ; .
		    clrf	Out3
		    clrf  	Out2      ;  .
		    clrf  	Out1
		    clrf  	Out0      ; .
loop16
		    rlf   	Buf_L,f      ; .  
		    rlf   	Buf_M,f
		    rlf   	Buf_H,f
		    rlf   	Buf_U,f      ; .
		    rlf   	Out0,f     		   ;    CF
		    rlf   	Out1,f
		    rlf   	Out2,f
		    rlf   	Out3,f
		    rlf   	Out4,f
		    decfsz 	Reg_2,f   ;Count:=Count-1,if Count=0 then skip next cmd
		    goto  	adjDEC
		    movfw 	Out4    		   ; w:= Lcd3
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out8    		   ; Lcd6:=w
		    swapf 	Out3,w  		   ;   Lcd3  
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out7    		   ; Lcd7:=w
		    movfw 	Out3    		   ; w:= Lcd3
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out6    		   ; Lcd6:=w
		    swapf 	Out2,w  		   ;   Lcd2  
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out5    		   ; Lcd5:=w
		    movfw 	Out2    		   ; w:= Lcd2
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out4    		   ; Lcd4:=w
		    swapf 	Out1,w  		   ;   Lcd1  
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out3    		   ; Lcd3:=w
		    movfw 	Out1    		   ; w:= Lcd1
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out2    		   ; Lcd2:=w
		    swapf 	Out0,w  		   ;   Lcd0  
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out1    		   ; Lcd1:=w
		    movfw 	Out0    		   ; w:= Lcd0
		    andlw 	0Fh     		   ;  -> w, w-> AND `00001111`
		    movwf 	Out0    		   ; Lcd0:=w
		     RETURN     	; ======  =======
adjDEC
			movlw 	Out0    		   ; w:= `H Lcd0`
			movwf 	FSR     		   ; FSR:= w
			call  	adjBCD
			movlw 	Out1   				; w:= `H Lcd1`
			movwf 	FSR     		   ; FSR:= w
			call  	adjBCD
			movlw 	Out2    		   ; w:= `H Lcd2`
			movwf 	FSR     		   ; FSR:= w
			call  	adjBCD
			movlw 	Out3    		   ; w:= `H Lcd3`
			movwf 	FSR     		   ; FSR:= w
			call  	adjBCD
			goto  	loop16
adjBCD
			movlw 	3         		   ; w:= 3
			addwf 	INDF,w    		   ; w:= IndF + 3
			movwf 	Count1  	   ; Count1:= w
			btfsc 	Count1,3  	   ; test if result > 7
			movwf 	INDF      		   ; IndF:= w
			movlw 	30        		   ; w:= 30
			addwf 	INDF,w     		   ; w:= IndF + 30
			movwf 	Count1    	   ; Count1:= w
			btfsc 	Count1,7  	   ; test if result > 7
			movwf 	INDF       		   ; save as MSD, IndF:= w
			retlw 	0         		   ; w:= 0
;;
;     .
No_Zero
			bcf		Flags,4
			movlw 	Out8 		; p  p p
			movwf 	FSR
CorrZ_Ret
			movfw	INDF
			btfsc	_Z
			goto	CorrZ_Loop0
			bsf		Flags,4		; No
CorrZ_Yes
			iorlw	0x30
CorrZ_0
			movwf	INDF
			decf	FSR,f
			movlw	Out0
			subwf	FSR,w
			btfss	_Z
			goto	CorrZ_Ret
			movlw	0x30
			iorwf	Out0,f
				RETURN
CorrZ_Loop0
			btfsc	Flags,4		;  ?
			goto	CorrZ_Yes	; 
			movlw	" "			; ,   
			goto	CorrZ_0

;;
mS_250
			movlw	.250		;  140 
			movwf	Reg_1     	;
			clrw
			addlw	.255        ; 
			btfss	_Z      	; 
			goto	$-2         ; 
			decfsz	Reg_1,f
			goto	$-5			;
				RETURN
;-----------------------------------------------------------------------;

;;


	include		"LCD_connection.h"

;-----------------------------------------------------------------------;
;;
;-----------------------------------------------------------------------;

				END
